<template>
  <div>
    <div class="flex items-center">
      <q-input
        v-model="endpoint"
        inverted-light
        color="white"
        stack-label="Endpoint"
        :before="[{
          icon: 'refresh',
          handler: dropEndpoint,
          condition: !!method.config.endpoint && method.config.endpoint !== endpoint,
        }]"
        :after="[{
          icon: 'cloud_download',
          handler: loadFields,
          condition: !!endpoint,
        }]"
      />
      <q-select
        v-model="method.config.defaultSortColumn"
        :disable="!availableColumns.length"
        inverted-light
        color="white"
        stack-label="Default sort column"
        :options="availableColumns"
        :filter="availableColumns.length > 10"
        clearable
        class="q-ml-sm"
      />
      <q-select
        v-model="method.config.defaultSortDirection"
        inverted-light
        color="white"
        stack-label="Direction"
        :options="availableDirections"
        class="q-ml-sm"
      />
    </div>
    <div class="q-mt-md">
      <q-checkbox
        v-model="method.config.isEditable"
        label="Editable"
      />
      <q-checkbox
        v-model="method.config.isRemovable"
        label="Removable"
        class="q-ml-sm"
      />
    </div>
    <div class="q-mt-md">
      <q-tabs inverted>
        <q-tab
          v-for="{label, key} in tabs"
          :key="key"
          :name="key"
          :label="label"
          slot="title"
          :default="key === 'columns'"
        />

        <q-tab-pane
          v-for="{key, component} in tabs"
          :key="key"
          :name="key"
        >
          <component
            :is="component"
            :config="method.config"
            :available-fields="availableFields"
          />
        </q-tab-pane>
      </q-tabs>
    </div>
  </div>
</template>

<script>
    import columns from '../column/columns';
    import editors from '../editor/editors';
    import endpointsMixin from '../../../../../../mixins/endpointsMixin';
    import filters from '../filter/filters';

    export default {
      name: 'listMethod',
      mixins: [endpointsMixin],
      watch: {
        // eslint-disable-next-line func-names
        'method.config.endpoint': function (endpoint) {
          this.endpoint = endpoint;
          this.loadFields();
        },
      },
      created() {
        if (this.method.config.endpoint) {
          this.loadFields();
        }
      },
      computed: {
        availableColumns() {
          return this.method.config.columns.map(({ label }, value) => ({
            label,
            value,
          }));
        },
      },
      data() {
        return {
          endpoint: this.method.config.endpoint,

          availableFields: [],

          availableDirections: [
            {
              label: 'Ascending',
              value: 'asc',
            },
            {
              label: 'Descending',
              value: 'desc',
            },
          ],

          tabs: [
            {
              label: 'Columns',
              key: 'columns',
              component: columns,
            },
            {
              label: 'Filters',
              key: 'filters',
              component: filters,
            },
            {
              label: 'Editors',
              key: 'editors',
              component: editors,
            },
          ],
        };
      },
      props: {
        method: {
          type: Object,
        },
      },
      methods: {
        loadFields() {
          this.fetchEndpointFields(this.method.config.endpoint)
            .then((res) => {
              this.availableFields = Object.keys(res[0]).map((value) => ({
                value,
                label: value,
              }));
            });
          this.method.config.endpoint = this.endpoint;

          if (!('filters' in this.method.config)) {
            this.method.config.filters = [];
          }
        },
        dropEndpoint() {
          this.endpoint = this.method.config.endpoint;
        },
      },
    };
</script>
